﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Text.RegularExpressions;

using TechnicalTools;
using TechnicalTools.Diagnostics;
using TechnicalTools.Logs;
using TechnicalTools.Model;
using TechnicalTools.Tools;

using ApplicationBase.Deployment.Data;

using FileInfo = ApplicationBase.Deployment.Data.FileInfo;


namespace ApplicationBase.Deployment
{
    public class Deployer : IUserInteractiveObject
    {
        public class EnvironmentWhereToDeploy
        {
            public EnvironmentConfig Env { get; internal set; }

            public string Name { get { return Env.Name; } }
            public eEnvironment Domain { get { return Env.Domain; } }

            public bool Release { get; set; }
        }
        [DebuggerDisplay("{" + nameof(SourceFileName) + ",nq}")]
        public class FileToDeploy
        {
            public string MainFolder { get; internal set; }

            public string SourceFullPath { get { return Path.Combine(MainFolder, SourceLocalPath, SourceFileName); } }

            public string SourceLocalPath { get; internal set; }
            public string SourceFileName { get; internal set; }

            public string TargetLocalPath { get { return _TargetLocalPath ?? SourceLocalPath; } set { _TargetLocalPath = value; } } string _TargetLocalPath;
            public string TargetFileName { get { return _TargetFilename ?? SourceFileName; } set { _TargetFilename = value; } } string _TargetFilename;
            public string TargetFullLocalPath { get { return Path.Combine(TargetLocalPath, TargetFileName); } }

            public string Hash { get; internal set; }
            public bool ToDeploy { get; set; }

            public FileToDeploy Clone()
            {
                return new FileToDeploy()
                {
                    MainFolder = MainFolder,
                    SourceLocalPath = SourceLocalPath,
                    SourceFileName = SourceFileName,
                    _TargetLocalPath = _TargetLocalPath,

                    Hash = Hash,
                    ToDeploy = ToDeploy
                };
            }
        }

        public Config Config { get; set; }

        protected internal Deployer(Config cfg)
        {
            Config = cfg;
        }
        static readonly ILogger _log = LogManager.Default.CreateLogger(typeof(Deployer));

        public List<EnvironmentWhereToDeploy> GetExistingEnvironments()
        {
            return Config.DataAccessor.LoadCollection<EnvironmentConfig>()
                                      .Select(env => new EnvironmentWhereToDeploy() { Env = env })
                                      .ToList();
        }

        public void CreateDesktopShortcut(eEnvironment domain, string envName, string launcherPath)
        {
            var caption = Config.ApplicationName;
            if (domain != eEnvironment.Prod)
                caption += " " + domain.GetDescription();
            if (domain != eEnvironment.Prod || envName != Filter.Default.EnvName)
                caption += " " + envName;
            launcherPath = Path.GetFullPath(Path.Combine(launcherPath, Config.LauncherExecutableName));
            ShortcutCreator.CreateOnDesktop(caption, launcherPath, args: "--domain=\"" + domain + "\" --envName=\"" + envName + "\"");
        }

        public virtual List<FileToDeploy> GetFilesToDeploy(Assembly mainAssembly = null)
        {
            var allDeployableFiles = GetDeployableFiles(mainAssembly);
            foreach (var df in allDeployableFiles)
                df.ToDeploy &= !df.SourceFileName.EndsWith(".vshost.exe.config")
                            && !df.SourceFileName.EndsWith(".vshost.exe")
                            //&& !df.SourceFileName.EndsWith($"\\{FrmLauncher.ApplicationExecutableName}.config")
                            && !df.SourceFileName.EndsWith("\\desktop.ini"); // generated by windows sometimes
            return allDeployableFiles;
        }
        List<FileToDeploy> GetDeployableFiles(Assembly mainAssembly = null)
        {
            mainAssembly = mainAssembly ?? Assembly.GetEntryAssembly();
            var dir = Path.GetDirectoryName(mainAssembly.Location);
            Debug.Assert(dir != null, nameof(dir) + " != null");
            var allFiles = Directory.GetFiles(dir, "*", SearchOption.AllDirectories);

            return allFiles.Select(f => new FileToDeploy()
            {
                MainFolder = dir,
                SourceLocalPath = Path.GetDirectoryName(f.Substring(dir.Length + 1)),
                SourceFileName = Path.GetFileName(f),
                Hash = File_Extensions.GetMD5HashFromFile(f),
                ToDeploy = true,
            })
            .OrderBy(f => f.SourceFullPath)
            .ToList();
        }

        public List<Tuple<string, List<FileToDeploy>>> GetLauncherFilesByBuildMode(string launcherBinPath, string mainFolder)
        {
            if (!Directory.Exists(launcherBinPath))
                throw new UserUnderstandableException("Launcher Bin Path is wrong, did you compile it (in release) ?", null);

            var result = new List<Tuple<string, List<FileToDeploy>>>();
            foreach (var buildModePath in Directory.GetDirectories(launcherBinPath))
            {
                if (!File.Exists(Path.Combine(buildModePath, Config.LauncherExecutableName)))
                    continue;
                var launcherExeAssembly = Assembly.LoadFrom(Path.Combine(buildModePath, Config.LauncherExecutableName)); // NOSONAR
                var dt = AssemblyHelper.RetrieveLinkerTimestamp(launcherExeAssembly);
                var isToOld = (DateTime.Now - dt).Hours > 1;
                string name = Path.GetFileName(buildModePath)
                            + (isToOld ? " (files are too old, recompile them!)" : "");
                var r = Tuple.Create(name, new List<FileToDeploy>());
                if (!isToOld)
                {
                    foreach (var file in Directory.GetFiles(buildModePath))
                        if (!file.Contains(".vshost.") && !file.EndsWith(".bak"))
                        {
                            r.Item2.Add(new FileToDeploy()
                            {
                                MainFolder = mainFolder,
                                SourceLocalPath = buildModePath,
                                SourceFileName = Path.GetFileName(file),
                                ToDeploy = true,
                                Hash = File_Extensions.GetMD5HashFromFile(file),
                                TargetLocalPath = "..",
                            });
                        }
                }
                result.Add(r);
            }
            if (result.IsEmpty())
                BusEvents.Instance.RaiseUserUnderstandableMessage("There is no version of launcher files to include in deployment!" + Environment.NewLine +
                                                                  "Please compile the project (\"Release\" build is better because it is only one file) and restart", _log);
            return result;
        }


        public Version AReleaseMustBeInstalled(EnvironmentConfig env, bool forCurrentVersion = true)
        {
            var lastVersion = GetVersionAllowedAndAvailable(env).FirstOrDefault();
            Version currentVersion = Deployer.GetCurrentVersion();
            var filter = new Filter() { Domain = env.Domain, EnvName = env.Name };
            if (!forCurrentVersion)
            {
                var path = FindBestVersionExePathOnDiskFor(filter, out var bestConsistentRelease);
                if (!string.IsNullOrWhiteSpace(path))
                    currentVersion = new Version(Path.GetFileName(path));
            }
                
            // Note : lastVersion available can be inferior to currentVersion 
            // if developper changed their mind because a regression has been found on last delivered version
            // if the old version of your app is removed from user computer, we have to reinstall it
            if (lastVersion == null || currentVersion == lastVersion)
                return null;
            if (lastVersion != null && currentVersion > lastVersion && IsVersionAllowed(filter, currentVersion) )
                return null; // Tolerated
            return lastVersion;
        }

        public static char NoticeableUIChange   { get; } = '❖';
        public static char NoticeableBehavior   { get; } = '⯁';
        public static char TechnicalBrick       { get; } = '⟡';
        public static char Bullet               { get; } = '•';

        public virtual void Deploy(List<FileToDeploy> toRelease, List<EnvironmentConfig> envs, string manifestFileName, string publicReleaseNote, string privateReleaseNote, byte[] gif, IProgress<string> pr)
        {
            if (toRelease.Count == 0)
                throw new UserUnderstandableException("No file to deploy!", null);
            if (envs.Count == 0)
                throw new UserUnderstandableException("No selected environment where to deploy!", null);
            if (toRelease.GroupBy(rf => rf.TargetFullLocalPath).Any(grp => grp.Count() >= 2))
                throw new UserUnderstandableException("Cannot have multiple files with same target path!", null);
            if (toRelease.Any(rf => rf.TargetFullLocalPath == manifestFileName))
                throw new UserUnderstandableException("A manifest file with same name is already in list of files to release!", null);


            var manifest = Config.DataAccessor.CreateInstance<FileWithContent>();
            manifest.FileName = manifestFileName;
            manifest.Content = Encoding.UTF8.GetBytes(GenerateManifestContent(toRelease));
            manifest.Hash = manifest.Content.ToMD5Hash();

            var alreadyInDb = Config.DataAccessor.LoadCollection<FileInfo>()
                                       .ToDictionary(f => f.Hash);
            if (alreadyInDb.Count == 0 && toRelease.All(f => !f.TargetFileName.EndsWith(Config.LauncherExecutableName)))
                throw new UserUnderstandableException("Launcher files must be released for application first release!", null);
            var toSend = toRelease.Where(f => !alreadyInDb.ContainsKey(f.Hash))
                                  .Select(f => Config.DataAccessor.CreateInstance<FileWithContent>().InlineInit(fwc => 
                                  {
                                      fwc.Hash = f.Hash;
                                      fwc.FileName = f.TargetFileName;
                                      fwc.Content = File.ReadAllBytes(f.SourceFullPath);
                                  }))
                                  // Sometimes identical file must be at different places (for example empty files)
                                  .GroupBy(f => f.Hash)
                                  // So we just need to take any of them (if one has a long name it is a good match because it is maybe more descriptive)
                                  .Select(grp => grp.OrderByDescending(f => f.FileName.Length).First())
                                  .ToList();
            if (!alreadyInDb.ContainsKey(manifest.Hash))
                toSend.Add(manifest);

            Version releasedVersion = GetNextAvailableVersionFromVersionNumberingSystem();

            IReadOnlyList<ReleasedFile> releaseSet = toRelease.Select(f => Config.DataAccessor.CreateInstance<ReleasedFile>().InlineInit(rf =>
            {
                rf.Year = (byte)releasedVersion.Major;
                rf.Month = (byte)releasedVersion.Minor;
                rf.Day = (byte)releasedVersion.Build;
                rf.Hour = (byte)releasedVersion.Revision;
                rf.Hash = f.Hash;
                rf.LocalPath = f.TargetLocalPath.IfNotBlankAddSuffix("\\") + f.TargetFileName;
            })).ToList();


            int i = 0;
            foreach (var fileToSend in toSend)
            {
                ++i;
                pr.Report($"Sending file {i} / {toSend.Count} (for a release of {releaseSet.Count} files) : {fileToSend.FileName}");
                Config.DataAccessor.CreateInDatabase(fileToSend);
            }
            Config.DataAccessor.CreateInDatabaseCollection(releaseSet);

            Config.DataAccessor.CreateInDatabase(Config.DataAccessor.CreateInstance<ReleasedFile>().InlineInit(rf =>
            {
                rf.Year = releaseSet.First().Year;
                rf.Month = releaseSet.First().Month;
                rf.Day = releaseSet.First().Day;
                rf.Hour = releaseSet.First().Hour;
                rf.Hash = manifest.Hash;
                rf.LocalPath = manifestFileName;
            }));


            if (!string.IsNullOrWhiteSpace(publicReleaseNote))
                Config.DataAccessor.CreateInDatabase(Config.DataAccessor.CreateInstance<ReleaseNoteWithContent>().InlineInit(rn =>
                {
                    rn.Version = releasedVersion;
                    rn.IsPublic = true;
                    rn.Note = publicReleaseNote.Trim();
                    rn.NoteTechnical = privateReleaseNote;
                    rn.ExplainingGIF = gif;
                    rn.HasGIF = gif != null;
                }));

            // We finally release these links
            // So as soon as user is able to see it the release is completed in database
            var versionAsDate = ToDate(releasedVersion);
            if ((versionAsDate - DateTime.Now).TotalHours < 6) // not over night ?
                versionAsDate = DateTime.Now; // Allow this release to be downloaded right now by user
            foreach (var env in envs)
                Config.DataAccessor.CreateInDatabase(Config.DataAccessor.CreateInstance<VersionAllowedByEnvironment>().InlineInit(vabe =>
                {
                    vabe.Environment_Id = env.Id;
                    vabe.Version_From = releaseSet.First().Version;
                    vabe.Version_To = releaseSet.First().Version;
                    vabe.EffectiveFromDate = DateTime.Now.TruncateUnderSeconds().NotSoonerThan(versionAsDate);
                }));

            // If Launcher (release version) has been sent
            if (toSend.Any(f => f.FileName == Config.LauncherExecutableName))
            {
                var exeReleased = toRelease.Single(f => f.TargetFileName == Config.LauncherExecutableName);
                // Trying to remove the launcher exe to prevent developper to release an old, *not recompiled*, version next time unless he recompile launcher explicitely
                try { File.Delete(exeReleased.SourceFullPath); }
                catch
                {
                    ExceptionManager.Instance.IgnoreExceptionAndBreak(() =>
                    {
                        if (File.Exists(exeReleased.SourceFullPath + ".bak"))
                            File.Delete(exeReleased.SourceFullPath + ".bak");
                        File.Move(exeReleased.SourceFullPath, exeReleased.SourceFullPath + ".bak");
                    });
                }
            }
        }

        public Version GetNextAvailableVersionFromVersionNumberingSystem()
        {
            var versionparts = VersionFinder.GetVersionOfExecutable().ToString().Split('.');
            var dt = new DateTime(2000 + byte.Parse(versionparts[0]),
                                  byte.Parse(versionparts[1]),
                                  byte.Parse(versionparts[2]),
                                  byte.Parse(versionparts[3]),
                                  0,
                                  0);
            var releasedFiles = Config.DataAccessor.LoadCollection<ReleasedFile>();
            while (releasedFiles.Any(rf => rf.Year == dt.Year - 2000 
                                        && rf.Month == dt.Month
                                        && rf.Day == dt.Day
                                        && rf.Hour == dt.Hour))
            {
                dt = dt.AddHours(1);
            }

            return new Version(dt.Year - 2000, dt.Month, dt.Day, dt.Hour);
        }
        public static DateTime ToDate(Version v)
        {
            return new DateTime(2000 + v.Major, v.Minor, v.Build, v.Revision, 0, 0);
        }

        string GenerateManifestContent(List<FileToDeploy> toRelease)
        {
            // Code de cette méthode lié au code de IsThisReleaseConsistent
            Debug.Assert(toRelease.Any());
            if (toRelease.Any(rf => rf.MainFolder != toRelease.First().MainFolder))
                throw new UserUnderstandableException("All MainFolder of file to deploy must be the same!", null);


            var manifestContent = new StringBuilder();

            var ignoredExtensions = new[] { ".cfg", ".config", ".log", ".ini" }; // ".ini" because sometimes windows add "desktop.ini" in folder and we dont care about this file
            manifestContent.AppendLine("# All files are hashed, except files with extension : " + string.Join(", ", ignoredExtensions));
            foreach (var rf in toRelease)
            {
                var fullLocalPath = Path.Combine(rf.TargetLocalPath, rf.TargetFileName);
                string hash = !ignoredExtensions.Contains(fullLocalPath.ToLowerInvariant()) &&
                              !Regex.IsMatch(fullLocalPath, @"\.log\.[0-9]{4}-[0-9]{2}-[0-9]{2}$", RegexOptions.IgnoreCase) &&
                              Path.Combine(rf.MainFolder, rf.TargetLocalPath).StartsWith(rf.MainFolder) // check if path is ouside of main folder (ie: TargetLocalPath contains some ".." stuff...
                            ? rf.Hash
                            : "";
                manifestContent.AppendLine(fullLocalPath + " : " + hash);
            }
            return manifestContent.ToString();
        }

        /// <summary> Return the versions of product allowed to run on this environment and that are available to be installed </summary>
        /// <param name="env"></param>
        /// <returns>List of version sorted from the most recent/up-to-date to the oldest one</returns>
        public List<Version> GetVersionAllowedAndAvailable(EnvironmentConfig env)
        {
            return GetVersionAllowedAndAvailable(new Filter {Domain = env.Domain, EnvName = env.Name});
        }
        public List<Version> GetVersionAllowedAndAvailable(Filter filter)
        {
            Debug.Assert(filter.Domain.HasValue);
            Debug.Assert(!string.IsNullOrWhiteSpace(filter.EnvName));

            var requester = Config.DataAccessor;
            var availableVersions = requester.GetAvailableVersions()
                                             // GetCurrentVersion may have been installed by the main/prod database 
                                             // and Config.DataAccessor is currnetly accessing another database (pre-prod, dev etc)
                                             // We consider GetCurrentVersion available because already installed.
                                             // This is very useful because, usually, only main/prod database contains meta data about all versions and authorizations
                                             // this way, databases for other domain (preprod, dev etc) may have zero meta data...
                                             // and we have to maintain only prod database
                                             .Concat(GetCurrentVersion()) 
                                             .ToList();
            var envs = requester.GetAvailableEnvironments(null, filter)
                                .ToDictionary(e => e.Id);
            
            var now = DateTime.Now;
            
            var allowedVersions = requester.LoadCollection<VersionAllowedByEnvironment>()
                                           .Where(p => envs.ContainsKey(p.Environment_Id))
                                           .Where(p => (!p.EffectiveFromDate.HasValue || now >= p.EffectiveFromDate)
                                                    && (!p.EffectiveToDate.HasValue || now < p.EffectiveToDate));
            
            return availableVersions.Where(v => IsVersionAllowed(v, allowedVersions))
                                    .OrderByDescending(v => v)
                                    .ToList();
        }

        public bool IsVersionAllowed(Filter filter, Version version)
        {
            Debug.Assert(filter.Domain.HasValue);
            Debug.Assert(!string.IsNullOrWhiteSpace(filter.EnvName));

            var requester = Config.DataAccessor;
            var envs = requester.GetAvailableEnvironments(null, filter)
                                .ToDictionary(e => e.Id);

            var now = DateTime.Now;

            var allowedVersionRanges = requester.LoadCollection<VersionAllowedByEnvironment>()
                                                .Where(p => envs.ContainsKey(p.Environment_Id))
                                                .Where(p => (!p.EffectiveFromDate.HasValue || now >= p.EffectiveFromDate)
                                                         && (!p.EffectiveToDate.HasValue || now < p.EffectiveToDate));
            return IsVersionAllowed(version, allowedVersionRanges);
        }
        bool IsVersionAllowed(Version version, IEnumerable<VersionAllowedByEnvironment> allowedVersionRanges)
        {
            return allowedVersionRanges.Any(a => (a.Version_From ?? MinVersion) <= version
                                              && (a.Version_To   ?? MaxVersion) >= version);
        }
        public static readonly Version MinVersion = new Version(0, 0, 0, 0);
        public static readonly Version MaxVersion = new Version(int.MaxValue, int.MaxValue, int.MaxValue, int.MaxValue);

        public static Version GetCurrentVersion(Assembly mainAssembly = null)
        {
            if (_curVersion != null)
                return _curVersion;
            mainAssembly = mainAssembly ?? Assembly.GetEntryAssembly();
            var dir = Path.GetDirectoryName(mainAssembly.Location);
            var dirVersion = Path.GetFileName(dir);
            Debug.Assert(dirVersion != null, nameof(dirVersion) + " != null");
            var parts = dirVersion.Split('.');
            if (parts.Length == 4) // As expected in production
                if (byte.TryParse(parts[0], out var y) &&
                    byte.TryParse(parts[1], out var m) &&
                    byte.TryParse(parts[2], out var d) &&
                    byte.TryParse(parts[3], out var h))
                {
                    _curVersion = new Version(y, m, d, h);
                    return _curVersion;
                }
                else
                    Debug.Fail("We should never been here ?");
            // In case of developper version 
            _curVersion = VersionFinder.GetVersionOfExecutable();
            return _curVersion;
        }
        static Version _curVersion;
        public static void SetCurrentVersion(Version version)
        {
            _curVersion = version;
        }



        public void Authenticate(string login, string user_password, eEnvironment? domain, string envName,IProgress<string> pr = null)
        {
            if (Config.DataAccessor.IsAuthenticationRequired && !Config.DataAccessor.IsAuthenticated)
            {
                pr = pr ?? new Progress<string>();
                pr.Report("Authenticating...");
                var env = Config.DataAccessor.GetAvailableEnvironments(null, new Filter() { Domain = domain, EnvName = envName }).LastOrDefault();
                Config.DataAccessor.Authenticate(env, login, user_password);
                Debug.Assert(Config.DataAccessor.IsAuthenticated);
            }
        }

        public string Install(Version versionToInstall, IProgress<string> pr = null)
        {
            pr = pr ?? new Progress<string>();

            string msgHeader = $"*** Installing Version {versionToInstall} ***" + Environment.NewLine;
            pr.Report(msgHeader);

            // Very often, the reference environment (prod) allowed user to connect to another remote environment
            // but the remote environment has not autorization set for running any version of {productName}
            // Developper must create a line in sql table "VersionAllowedByEnvironment"
            if (versionToInstall == null) 
                throw new UserUnderstandableException($"No version of {Config.ApplicationName} allowed to connect to this remote environment. Ask an IT!", null);

            var exePath = Assembly.GetEntryAssembly().Location;
            if (exePath.StartsWith(@"\\") || new DriveInfo(exePath).DriveType == DriveType.Network)
                throw new UserUnderstandableException("Please copy the installer somewhere on your computer (on your desktop for example) and run it again." + Environment.NewLine +
                                                      "Because Windows' security policy does not allow programs to be executed from a network drive and connect to a server.", null);
            msgHeader += "Getting list of files composing this version...";
            pr.Report(msgHeader);
            var allHashes = Config.DataAccessor.LoadReleasedFilesFor(versionToInstall);
            var hashOfFilesToGet = allHashes.OrderBy(rf => rf.LocalPath)
                                            .ToList();

            AddLauncherFilesFromPreviousVersionIfMissing(hashOfFilesToGet);

            msgHeader += hashOfFilesToGet.Count.ToString() + Environment.NewLine;
            msgHeader += "Searching unchanged files from previous versions";
            pr.Report(msgHeader);

            Directory.CreateDirectory(Config.DeployRepository);
            var presentFiles = Directory.GetFiles(Config.DeployRepository, "*", SearchOption.AllDirectories)
                                        .OrderByDescending(f => f) // most up to date first
                                        .ToLookup(Path.GetFileName);
            var versionDir = Path.Combine(Config.DeployRepository, versionToInstall.ToString());

            Directory.CreateDirectory(versionDir);
            var toDownload = GetFilesFromDisk(hashOfFilesToGet, presentFiles, versionDir);

            msgHeader += $"{hashOfFilesToGet.Count - toDownload.Count} files already owned on {hashOfFilesToGet.Count}." + Environment.NewLine
                       + $"{toDownload.Count} file{(toDownload.Count <= 1 ? "" : "s")} need{(toDownload.Count == 1 ? "s" : "")} to be downloaded.";
            if (toDownload.Count > 0)
            {
                DownloadFiles(versionDir, toDownload, (f, cur, length) =>
                    pr.Report(msgHeader + Environment.NewLine
                            + $"Downloading file {toDownload.IndexOf(f) + 1} on {toDownload.Count} : {f.LocalPath}" + Environment.NewLine
                            + $"   Progress : {(length == 0 ? 100 : cur * 100.0m / length):0.00} %"));
            }

            pr.Report(msgHeader + " [Done]");

            return Path.Combine(Config.DeployRepository, Config.LauncherExecutableName);
        }

        static List<ReleasedFile> GetFilesFromDisk(List<ReleasedFile> hashOfFilesToGet, ILookup<string, string> presentFiles, string versionDir)
        {
            var toDownload = new List<ReleasedFile>();
            foreach (var hashOfFileToGet in hashOfFilesToGet)
            {
                bool found = false;
                foreach (var fileWithSameName in presentFiles[Path.GetFileName(hashOfFileToGet.LocalPath)])
                {
                    var md5 = File_Extensions.GetMD5HashFromFile(fileWithSameName);
                    if (md5 == hashOfFileToGet.Hash)
                    {
                        var targetPath = Path.GetFullPath(Path.Combine(versionDir, hashOfFileToGet.LocalPath));
                        if (fileWithSameName != targetPath)
                        {
                            var parentDir = Path.GetDirectoryName(targetPath);
                            Debug.Assert(parentDir != null, nameof(parentDir) + " != null");
                            Directory.CreateDirectory(parentDir);
                            File.Copy(fileWithSameName, targetPath, true);
                        }

                        found = true;
                        break;
                    }
                }

                if (!found)
                    toDownload.Add(hashOfFileToGet);
            }

            return toDownload;
        }

        void AddLauncherFilesFromPreviousVersionIfMissing(List<ReleasedFile> hashOfFilesToGet)
        {
            if (hashOfFilesToGet.All(rf => Path.GetDirectoryName(rf.LocalPath) != ".."))
            {
                // All versions of launcher are supposed compatible with older version of Application
                var filesForLauncher = Config.DataAccessor.LoadRecentReleasedFilesWithPathStartingWith("..");
                if (!filesForLauncher.Any())
                    throw new UserUnderstandableException($"The launcher files like {Config.LauncherExecutableName} are expected at least in the first delivery !", null);

                foreach (var fileForLauncher in filesForLauncher)
                    hashOfFilesToGet.Add(fileForLauncher);
            }
        }


        void DownloadFiles(string mainFolder, List<ReleasedFile> files, Action<ReleasedFile, long, long> progress = null)
        {
            progress = progress ?? ((_, __, ___) => { });

            foreach (var file in files)
            {
                var length = Config.DataAccessor.GetFileLength(file);
                var uniqueBuffer = new byte[128 * 1024];
                int cumulatedRead = 0;

                var hdFile = Path.GetFullPath(Path.Combine(mainFolder, file.LocalPath));
                ReplaceFileSafely(hdFile, () =>
                {
                    progress(file, cumulatedRead, length);

                    var parentDir = Path.GetDirectoryName(hdFile);
                    Debug.Assert(parentDir != null, nameof(parentDir) + " != null");
                    Directory.CreateDirectory(parentDir);
                  
                    using (var fsOut = new FileStream(hdFile, FileMode.Create, FileAccess.Write))
                        foreach (var read in Config.DataAccessor.DownloadFileByChunk(file, uniqueBuffer, length))
                        {
                            fsOut.Write(uniqueBuffer, 0, read);
                            fsOut.Flush();
                            cumulatedRead += read;
                            progress(file, cumulatedRead, length);
                        }
                });
            }
        }

        static void ReplaceFileSafely(string file, Action action)
        {
            // Important note : Moving a file, even if it is in use (like an exe file) is always allowed by windows
            // However the delete is not allowed if the file is in use
            // In this method we try to not throw exception but it is not 100% sure

            var bakFile = file + ".bak";
            var fileToDelete = file + ".delete_me." + Guid.NewGuid(); // use an easy pattern to be able find again these files (in case deletion did not work)
            if (File.Exists(bakFile))
                ExceptionManager.Instance.IgnoreExceptionAndBreak(() => File.Move(bakFile, fileToDelete));
            if (File.Exists(file))
                File.Move(file, bakFile);
            try
            {
                action(); // Action that recreate file "file"
                if (File.Exists(bakFile))
                    ExceptionManager.Instance.IgnoreExceptionAndBreak(() => File.Move(bakFile, fileToDelete));
            }
            catch // "action" failed
            {
                if (File.Exists(file))
                    ExceptionManager.Instance.IgnoreExceptionAndBreak(() => File.Move(file, fileToDelete));
                if (File.Exists(bakFile))
                    ExceptionManager.Instance.IgnoreExceptionAndBreak(() => File.Move(bakFile, file));
                throw;
            }
            finally
            {
                if (File.Exists(fileToDelete))
                    ExceptionManager.Instance.IgnoreExceptionAndBreak(() => File.Delete(fileToDelete));
            }
        }


        public string FindBestVersionExePathOnDiskFor(Filter filter, out string bestConsistentRelease)
        {
            bestConsistentRelease = null;

            CleanTempFileFromLastDeployment();

            var dirs = Directory.EnumerateDirectories(Config.DeployRepository)
                                .Select(folderPath =>
                                {
                                    var folderNameWithVersion = Path.GetFileName(folderPath);
                                    Debug.Assert(folderNameWithVersion != null, nameof(folderNameWithVersion) + " != null");
                                    return new
                                    {
                                        Path = folderPath,
                                        Version = Version.TryParse(folderNameWithVersion, out var v) ? v : null
                                    };
                                })
                                .Where(t => t.Version != null)
                                .OrderByDescending(v => v.Version);
            foreach (var f in dirs)
            {
                var errors = IsThisReleaseConsistent(f.Path, Config.ManifestFileName);
                if (errors.Count > 0)
                    continue;
                bestConsistentRelease = bestConsistentRelease ?? f.Path;

                Debug.Assert(filter.Domain != null, "_filter.Domain != null");
                if (IsThisReleaseCompatible(f.Path, filter.Domain.Value, filter.EnvName))
                    return f.Path;
            }
            return null;
        }

        public void CleanTempFileFromLastDeployment()
        {
            ExceptionManager.Instance.IgnoreExceptionAndBreak(() =>
            {
                foreach (var fileToDelete in Directory.GetFiles(".", "*.delete_me.*", SearchOption.AllDirectories))
                    File.Delete(fileToDelete);
            });
        }

        public bool IsCompatible(Version version, eEnvironment domain, string envName)
        {
            var filter = new Filter()
            {
                Domain = domain,
                EnvName = envName
            };
            return Config.DataAccessor.GetAvailableEnvironments(version, filter).Any();
        }

        public List<string> IsThisReleaseConsistent(Version version)
        {
            var appData = Path.Combine(Config.DeployRepository, version.ToString());
            return IsThisReleaseConsistent(appData, Config.ManifestFileName);
        }
        public List<string> IsThisReleaseConsistent(string path, string manifestFile)
        {
            // Code de cette méthode lié au code de GenerateManifestContent
            if (!File.Exists(Path.Combine(path, manifestFile)))
                return new List<string> { "Manifest file not found!" };
            if (!File.Exists(Path.Combine(path, Config.GuiExecutableName)))
                return new List<string> { "Main exe file not found!" };
            var lines = File.ReadAllLines(Path.Combine(path, manifestFile)).Where(line => !line.StartsWith("#")).ToArray();
            var missingFiles = new List<string>();
            var invalidFiles = new List<string>();
            foreach (var line in lines)
            {
                if (string.IsNullOrWhiteSpace(line))
                    continue;
                var parts = line.Split(new[] { " : " }, StringSplitOptions.RemoveEmptyEntries);
                var file = parts[0];
                var expectedHash = parts.Length >= 2 ? parts[1] : null;
                if (file.StartsWith("..")) // launcher files version may be > current version test
                    continue; // so no test
                if (!File.Exists(Path.Combine(path, file)))
                    missingFiles.Add(file);
                else if (expectedHash != null)
                {
                    var hash = File_Extensions.GetMD5HashFromFile(Path.Combine(path, file));
                    if (hash != expectedHash)
                        invalidFiles.Add(file);
                }
            }

            var version = Path.GetFileName(path);
            var errors = new[]
            {
                missingFiles.Count == 0 ? null : $"Release of {Config.ApplicationName} v{version} is incomplete..." + Environment.NewLine +
                                                 "Missing files are:" + Environment.NewLine +
                                                 string.Join(Environment.NewLine, missingFiles.Select(f => " - " + f)),
                invalidFiles.Count == 0 ? null : $"Some files are incorrect/corrupted for the {Config.ApplicationName} v{version}" + Environment.NewLine +
                                                 Environment.NewLine +
                                                 "Call an IT."  + Environment.NewLine +
                                                 "Invalid/Corrupted files are:" +
                                                 string.Join(Environment.NewLine, invalidFiles.Select(f => " - " + f)),
            }.NotBlank().ToList();

            return errors;
        }

        public bool IsThisReleaseCompatible(string folder, eEnvironment domain, string envName)
        {
            var psi = new ProcessStartInfo
            {
                FileName = Path.Combine(folder, Config.GuiExecutableName),
                WorkingDirectory = folder, // Important !
                Arguments = $"--execute=CheckEnvironmentCompatibility --domain=\"{domain}\"  --envName=\"{envName}\"",
                RedirectStandardError = true,
                RedirectStandardOutput = true,
                RedirectStandardInput = true,
                UseShellExecute = false
            };
            //  psi.CreateNoWindow = true;

            var p = Process.Start(psi);
            Debug.Assert(p != null, nameof(p) + " != null");
            // In ideal condition, process should take 1s to return. In case of bad wifi we never know...
            // p.WaitForExit(30000);
            p.WaitForExit();
            return p.ExitCode == 0;
        }


        public Process StartVersion(eEnvironment domain, string envName)
        {
            var psi = new ProcessStartInfo
            {
                FileName = Path.Combine(Config.DeployRepository, Config.LauncherExecutableName),
                WorkingDirectory = Config.DeployRepository, // Important !
                Arguments = $"--domain=\"{domain}\"  --envName=\"{envName}\""
            };
            return Process.Start(psi);
        }
        public Process StartVersion(Version version, eEnvironment domain, string envName)
        {
            var versionDir = Path.Combine(Config.DeployRepository, version.ToString());
            return StartVersion(versionDir, domain, envName);
        }
        public Process StartVersion(string folder, eEnvironment domain, string envName)
        {
            var psi = new ProcessStartInfo
            {
                FileName = Path.Combine(folder, Config.GuiExecutableName),
                WorkingDirectory = folder, // Important !
                Arguments = $"--execute=ShowMainGui --domain=\"{domain}\"  --envName=\"{envName}\""
            };
            return Process.Start(psi);
        }
        public Process StartVersionForDevelopper(eEnvironment domain, string envName)
        {
            var app = Path.GetDirectoryName(Assembly.GetEntryAssembly().Location);
            var newArgs = Environment.GetCommandLineArgs()
                                     .Where(a => !a.EndsWith(".vshost.exe"))
                                     .Where(a => !a.StartsWith("#"))
                                     .Where(a => !a.ToLowerInvariant().StartsWith("--domain=")
                                              && !a.ToLowerInvariant().StartsWith("--envName="))
                                     .Concat(new[] { "--domain=" + domain.ToString(),
                                                     "--envName=" + envName })
                                     .ToList();
            var psi = new ProcessStartInfo();
            Debug.Assert(app != null, nameof(app) + " != null");
            psi.FileName = Path.Combine(app, Config.GuiExecutableName);
            psi.Arguments = newArgs.Join(" ");
            psi.WorkingDirectory = app;
            return Process.Start(psi);
        }

        // Return the list of available environment user is able to connect to
        // The result is independent of if version of software are actually configured to execute on these environments
        public List<EnvironmentConfig> GetAvailableEnvironmentsForUser(IProgress<string> pr)
        {
            var accessor = Config.DataAccessor;
            var envs = accessor.GetAvailableEnvironments(null, new Filter())
                               // Hide technical environments
                               .Where(env => !env.IsHiddenFromUser)
                               // Display only environnement where there is a Application version currently allowed
                               .Where(env => GetVersionAllowedAndAvailable(env).Any())
                               // must be sync with the property SortOrder below, in order to make GetNotInListValue handler consistent
                               .OrderBy(env => env.Domain.ToString())
                               .ToList();
            return envs;
        }
    }
}
